from Acquisition import Implicit, aq_base, aq_inner
from ExtensionClass import Base
from ComputedAttribute import ComputedAttribute
from TW.Aspects import Aspect


class ComputedFeature(Implicit):

    def __init__(self,func):
        self.func = func

    def values(self):
        return self.func(self.aq_inner.aq_parent).data

    __call__ = values

def _nameOf(item):
    if hasattr(item,'name'): return item.name()
    return item._key
    





















class Misc(Aspect):

    def __init__(self): self.clear()
        
    def itemToKey(self,item):
        if item is None or type(item) is StringType:
            return item
        if not hasattr(item,'_key'):
            self.register(item)
        return item._key

    def keyToItem(self,key):
        if key is None or hasattr(key,'_key'): return key
        return self.data[key].__of__(aq_inner(self))

    def newItem(self,itemType,key=None,*args,**kw):
        if key and self.data.has_key(key):
            #k=self.data[key].__class__
            #if itemType not in (k._ElementType,)+k._XMINames:
            #    raise TypeError,"Changing type of item '%s' from %s to %s" % (key,k._ElementType,itemType)
            return self.keyToItem(key)
        if not self._Classes.has_key(itemType):
            return None
        item = self._Classes[itemType]()
        self.register(item,key)
        item = item.__of__(aq_inner(self))
        apply(item.__init__,args,kw)
        return item
        
    def register(self,item,key=None):
        if key is None:
            key=self.genKey(item)            
        item._key = key
        self.data[key]=aq_base(item)

    def has_key(self,key): return self.data.has_key(key)

    keyNum = 0



    def genKey(self,item):
        # XXX try doing path algorithm first
        have = self.data.has_key
        while 1:
            key = self.keyNum = self.keyNum+1
            key = 'xmi_%d' % key
            if not have(key): return key

    def values(self):
        return map(lambda x,s=aq_inner(self): x.__of__(s), self.data.values())

    def clear(self):
        self.data = {}
        self.typeIndex = {}
        self.keyNum = 0
        self.roots = []
        self.Roots = NodeList(self.roots)
        























    class ref_feature:

        _defaultValue = None
    
        def __init__(self,role,referencedType,xmi_name,reverseRole,navigable):
            self.name, self.refType, self.reverse = role, referencedType, reverseRole
            self.xmi_name, self.navigable = xmi_name, navigable

        def set(self,item):
            me = aq_inner(self.aq_parent)
            if self._value():
                getattr(self(),self.reverse)._remove(me)
                if item is not None:
                    getattr(item,self.reverse)._add(me)
            self._set(item)
        
        def _set(self,item):
            self._setValue(self.itemToKey(item))

        def _add(self,item):
            #now = self._value()
            #if now is not None and now != self.itemToKey(item):
            #    raise ValueError,"Inconsistent assignment"
            self._set(item)

        def _remove(self,item):
            #if self._value() != self.itemToKey(item):
            #    raise ValueError,"Inconsistent removal"
            self._setValue(None)
        
        def __call__(self):        return self.keyToItem(self._value())










    class list_feature:

        def _list(self):
            d = self.aq_parent._values; n = self.name
            if d.has_key(n): return d[n]
            l = d[n] = []; return l

        def add(self,item):
            self._add(item)
            getattr(item,self.reverse)._add(aq_inner(self.aq_parent))

        def set(self,values):
            role = self.reverse; me = aq_inner(self.aq_parent)
            for item in self.values(): getattr(item,role)._remove(me)
            for item in values: getattr(item,role)._add(me)
            self._set(values)

        def remove(self,item):
            self = self.aq_inner; me = aq_inner(self.aq_parent)

            getattr(item,self.reverse)._remove(me)

            self._remove(item)
        
        def __call__(self):
            return map(self.keyToItem,self._list())

        def _add(self,item):
            l = self._list(); key = self.itemToKey(item)
            if key not in l: l.append(key)
        
        def _remove(self,item): self._list().remove(self.itemToKey(item))
        def _set(self,values):  self._setValue(map(self.itemToKey,values))

        values = __call__






    class bag_feature(list_feature):

        def __call__(self):
            d={}
            for k,v in self.items():
                if k: d[k] = v
            return d

        def items(self):
            l=[]
            for v in map(self.keyToItem,self._list()):
                l.append( _nameOf(v), v )
            return l
        
        def __getitem__(self,key): return self()[key]
    
        def get(self,key,fail=None):    return self().get(key,fail)

    






















class Storage(Aspect):

    class attribute_feature(Implicit):

        def __call__(self):
            return self.aq_parent._values.get(self.name,aq_base(self._defaultValue))

        _getValue = __call__
    
        def _setValue(self,value):
            self.aq_parent._values[self.name]=aq_base(value)


    class type_flavor(Base):
        pass


























class Structure(Aspect):

    class attribute_feature:

        """An attribute of an element"""
        
        navigable = 1

        def __init__(self,*args,**kw):
            self.__dict__.update(kw)

        def values(self):
            """Return the value(s) of the feature as a sequence, even if it's a single value"""
            value = self()
            if value is None: return []
            return [value]

        def __call__(self):
            """Return the value of the feature"""
            return aq_acquire(self,'_getValueFor')(self)

        def isEmpty(self):
            """Is the value currently set?"""
            return self() is not None
            
        def set(self,value):
            """Set the value of the feature to value"""
            return aq_acquire(self,'_setValueFor')(self,value)

        def clear(self):
            """Unset the value of the feature (like __delattr__)"""
            return aq_acquire(self,'_clearValueFor')(self)

        def addItem(self,item):
            """Add the item to the collection/relationship, reject if multiplicity exceeded"""
            if self.isEmpty():
                return aq_acquire(self,'_setValueFor')(self,item)
            #raise MultiplicityExceeded



        def removeItem(self,item):
        
            """Remove the item from the collection/relationship, if present"""
            
            if item is self() and item is not None:
                return aq_acquire(self,'_clearValueFor')(self)


        def addNewItem(self,*args,**kw):
        
            """Create a new object in the collection of the appropriate type, passing through args/kw
               and returning the newly created object."""
               
            if self.isEmpty(): pass
            #    raise MultiplicityExceeded
               
            return aq_acquire(self,'_addNewItemFor')(self,args,kw)


    class ref_feature(attribute_feature):
        """A typed reference to another element"""
        
    class list_feature(ref_feature):
        """A typed sequence of references to other elements"""

    class bag_feature(list_feature):
        """An unordered collection of references to other elements"""














    class type_flavor(Implicit):
        """Basis for all flavors"""

    class primitive_flavor(type_flavor):
        """A primitive type (e.g. Boolean, String, etc.)"""

    class enumeration_flavor(type_flavor):
        """An enumerated type"""

    class datatype_flavor(type_flavor):
        """A complex datatype"""

    class element_flavor(datatype_flavor):
        """An element in its own right"""



























class Representation(Aspect):

    class attribute_feature:

        _dontRepr = None
    
        def __repr__(self):
            return self.valueKind._repr(self._value())
        
    class ref_feature:
    
        def __repr__(self):
            value = self()
            return value._repr(value)

    class parent_ref_feature(ref_feature):
        """A reference to a composition parent element"""
        _dontRepr = 1


    class list_feature:

        def __repr__(self):
            return `self()`

















    class primitive_flavor:

        _defaultValue = None
    
        def __init__(self,value=None):
            if value is not None:
                self._defaultValue = self._convert(value)

        def _repr(self,value):
            return '%s(%s)' % (self.__class__.__name__,`value`)
        
        def _convert(self, value):
            raise TypeError,"No converter defined"

        def __repr__(self):
            return self._repr(self._defaultValue)


    class enumeration_flavor:

        def __init__(self,value=None):
            self._defaultValue = value or getattr(self,self.__featureNames__[0])

        def _convert(self,value):
            if value in self.__featureNames__: return value
            raise ValueError,"Invalid value '%s' for enumeration type %s" % (value,self.__class__.__name__)

        def _repr(self,value):
            return '%s.%s' % (self.__class__.__name__,value)












    class datatype_flavor:

        def _defaultValue(self): return self
        
        _defaultValue = ComputedAttribute(_defaultValue)

        def __init__(self,*args,**kw):
            if getattr(self,'Abstract',0):
                raise TypeError,"Attempt to instantiate abstract element class %s" % self.__class__.__name__
            if args and not kw:
                kw = self._convert(args[0])._values
            self._values={}
            for k,v in kw.items():
                if k in self.__featureNames__:
                    getattr(self,k).set(v)
                else:
                    raise TypeError,"No such attribute or association '%s' for type %s" % (k,self.__class__.__name__)

        def __str__(self):
            return "%s(%s)" % (self.__class__.__name__,`self._key`)
        
        def __repr__(self):
            d={}
            for k in self._values.keys():
                v=getattr(self,k)
                if not v._dontRepr: d[k]=v()
            return self._repr(d)
        
        def _repr(self,value):
            klass = self.__class__; s=''
            if type(value)==type({}):
                # format as dictionary
                import string
                s = string.join(map(lambda x: "%s=%s" % (x[0],x[1]),value.items()),',')
        
            if getattr(value,'__class__',None) is klass:
                return value.__repr__()
            
            return '%s(%s)' % (klass.__name__, s)


        def _convert(self,value):
            klass = self.__class__
            if type(value)==type({}):
                return apply(self.newItem,(klass._ElementType,),value)
            
            if getattr(value,'__class__',None) is klass:
                return value
            
            raise TypeError,"No converter defined"

































